library(ruODK)
library(filesstrings)
library(reshape2)
library(data.table)
library(jsonlite)
library(rjson)
library(stringr)

projet="Silva"
#formulaire="test_geom"
#formulaire="Arboretum abattage 2023"
formulaire="Etiquetage arboretum"
#formulaire="complexe  double repet" #Il s'agit du nom visible par form_list(pid=N)$name

#projet="AG GEDEOP Atelier ODK 190123"
#formulaire="atelier_odk_ag_gedeop2023"

chemin_scripts="d://projets//odk//ruodk"

############################################
########      Programme principal    #######
############################################
setwd(chemin_scripts)	#positionnement dans le dossier contenant les scripts

#source le code des différents scripts R utilisés
source("constantes.r")				# Script contenant les variables / constantes à personnaliser seln votre usage ...
source("informations_connexion.r")	# Constantes confidentielles de login à la plateforme
source("json_tools.r")
source("fonctions.r")				# Script des fonctions utilisées

connexion_odkcentral(serveur=url_odk_central,username=login_odk,password=mot_de_passe)

#***** Via l'API
#Utilise l'API pour récupérer un fichier JSON des soumissions
recupere_soumission(nom_du_projet=projet,nom_du_formulaire=formulaire,"API","","JSON","D:\\projets\\odk\\ruodk\\etude\\sortie\\api\\json",FALSE)

#Utilise l'API pour récupérer un fichier CSV fusionné des soumissions
recupere_soumission(nom_du_projet=projet,nom_du_formulaire=formulaire,"API","","CSV","D:\\projets\\odk\\ruodk\\etude\\sortie\\api\\csv",FALSE)

#Utilise l'API pour récupérer un ensemble de fichiers CSV des soumissions (uniquement pour les formulaires avec répétition
#recupere_soumission(nom_du_projet=projet,nom_du_formulaire=formulaire,"API","","MULTICSV","D:\\projets\\odk\\ruodk\\etude\\sortie\\api\\multicsv",FALSE)

#***** Via la récupération de l'archive zip
#Utilise l'archive zip pour récupérer un fichier JSON des soumissions
recupere_soumission(nom_du_projet=projet,nom_du_formulaire=formulaire,"ZIP","","JSON","D:\\projets\\odk\\ruodk\\etude\\sortie\\zip\\json",FALSE)

#Utilise l'archive zip pour récupérer un fichier CSV fusionné des soumissions
recupere_soumission(nom_du_projet=projet,nom_du_formulaire=formulaire,"ZIP","","CSV","D:\\projets\\odk\\ruodk\\etude\\sortie\\zip\\csv",FALSE)

#Utilise l'archive zip pour récupérer un ensemble de fichiers CSV des soumissions (uniquement pour les formulaires avec répétition
recupere_soumission(nom_du_projet=projet,nom_du_formulaire=formulaire,"ZIP","","MULTICSV","D:\\projets\\odk\\ruodk\\etude\\sortie\\zip\\multicsv",FALSE)

#***** A venir : la récupération d'une base au format SQL Lite via l'API u via l'archive zip